/*****************************************************************************/
/*                                                                           */
/*                                Batalla Naval                              */
/*                                  cliente X                                */
/*                             por Ricardo Quesada                           */
/*                                                                           */
/*****************************************************************************/
/*   Cualquier bug, mejora, etc... enviala cualquiera de estas direcciones:  */
/*                           rquesada@dc.uba.ar                              */
/*                        rquesada@era.balug.org.ar                          */
/*                            4:900/309.3@fidonet                            */
/*****************************************************************************/
/*           Distribucion del programa: GNU General Public License v2        */
/*****************************************************************************/


/********************************************/
/* Librerias para X - Usa xview y Slingshot */
/********************************************/
#include <X11/Xlib.h> 
#include <xview/xview.h> 
#include <xview/window.h> 
#include <xview/openmenu.h> 
#include <xview/panel.h>
#include <xview/canvas.h>
#include <xview/xv_xrect.h>
#include <xview/frame.h>
#include <xview/cms.h>
#include <xview/notify.h>
#include <xview/svrimage.h>     /* new on v0.31 */
#include <xview/icon.h>         /* new on v0.31 */
#include <xview/ttysw.h>        /* new on v0.32 */
#include <sspkg/canshell.h>
#include <sspkg/array.h>
#include <sspkg/drawobj.h>

/* includes para sockets y otras yerbas */
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <unistd.h>
#include <netdb.h>
#include <stdio.h>
#include <syslog.h>
#include <errno.h>
#include <string.h>
#include "protocol.h"           /* definicion del protocolo */
#include "tablas.h"             /* boards for win,lost,etc. new on v0.30 */

/*
 *                DEFINES
 */ 
#define  WHITE  0  
#define  BLACK  1
#define  BLUE   2
#define  GREEN  3
#define  LBLUE  4
#define  YELLOW 5
#define  RED    6

#define MAXPLAYER 5
#define BN_XVER "0.46"
#define BN_XVERH 0
#define BN_XVERL 46

#define LARGO 21                       /* tricky. i need this in v0.43 */
#define ANCHO 20

#define RAPID 10                       /* the lower, more time for select() */

/* 
 *                   VARIABLES GLOBALES
 */

int sock;
struct sockaddr_in server;
struct hostent *host_info;
char mitabla[10][10];          /* mi tabla de barcos */
char tutabla[10][10];          /* tabla para disparar */
char barquitos[4];             /* tama;os de los barcos 1 de 4, 2 de 3, etc. */
short int x,y;                 /* punteros de la tabla mia */
Drawrect barcos_ptr[100];      /* nombre de los objetos de cada barco */
Drawrect tusbarcos_ptr[100];   /*   "     "    del enemigo */

Frame frame,subframe1,subframe2,subframe3;
Panel panel,panelcito,panelinfo,panelcit2,panel3,panelcit3,panelcit4,panelcit5;
Canvas canvas;
Menu menu;
Menu_item mi[MAXPLAYER];                 /* new on v0.36 */
Drawrect proto_drawrect;                 /* sspkg */
Array_tile array_tile;                   /* sspkg */
Drawtext   drawtext1;                    /* sspkg */
Rectobj_ops *rectobj_ops;                /* sspkg */
Canvas_shell shell,tushell;
Cms cms;
Server_image icon_image;                 /* new on v0.31 */
Icon icon;                               /* new on v0.31 */
Tty  tty;                                /* new on v0.32 */
GC gc;
XGCValues gc_val;
Display *display;
XID xid;
fd_set readfds;                           /* used by proceso() */
struct itimerval timer;                   /* used by proceso() */
char bnsup;                               /* usado por bnwrite */

#ifndef __linux
struct timeval timeout=  { 0,250000 };
#else
struct timeval timeout;
#endif

unsigned long *colors;

static Xv_singlecolor cms_colors[]= {
     { 255,255,255 },              /* white */
     {   0,  0,  0 },              /* black */
     {   0,  0, 255},              /* blue  INVERTED in v0.29 */
     {   0,255,  0 },              /* green INVERTED in v0.29 */
     {  30,230, 250},              /* light blue */
     { 255,255,  0 },              /* yellow */
     { 255,  0,  0 },              /* red */
};


/* pasa a ser memoria compartida v0.18 */
/* que loco, no? porque desde la 0.28 que ya no se usa mas */
struct usuario {
   char server_name[50];             /* server name */
   int port;                         /* server port */
   char nombre[MAXNAMELEN];          /* user name */
   char names[MAXPLAYER][MAXNAMELEN]; /* other players's name */

   int firsthit;                     /* para borrar BN new on 0.30 */
   int play;                         /* already playing ? */
   int numjug;                       /* number of player */
   int usrfrom;                      /* player who is owner of enemy window */
   
   char tomsg[MSGMAXLEN];            /* usuadas para mandar mensajes */
   int  towho;
   int  lecho;                       /* local echo */

   char status[5][16];               /* new on v0.43 */
   int  hide;                        /* hide my board new on v0.44 */
} usuario;

char fijo01[MSGMAXLEN];

#include "batnav.icon.h"                /* fucking icono */


/* 
 *                        FUNCIONES
 */


/* 
 * funciones varias
 */

/*
 * mandar mensajes a la teletype (tty)
 * new on v0.32
 */
void ttyfill(char msg[]) {
   char messg[100];                       /* i must do this to prevent segmentation fault. Que loco */
   strcpy(messg,msg);
   ttysw_output(tty,messg,strlen(messg));
}

/* 2 funciones para escribir mensajes abajo */
void foot_right( char msg[] ) {
   char tempbuf[100];
   strcpy(tempbuf,msg);                      /* perhaps this prevent the segmentation fault */
   xv_set(frame,
	  FRAME_RIGHT_FOOTER,tempbuf,
	  NULL);
}
void foot_left( char msg[] ) {
   char tempbuf[100];
   strcpy(tempbuf,msg);
   xv_set(frame,
	  FRAME_LEFT_FOOTER,tempbuf,
	  NULL);
}
/* paint mi cell */
void pmicell(int x,int y,int color) {
   int i;
   i=10*y+x;
   xv_set(barcos_ptr[i],
	  RECTOBJ_BG, color,
	  NULL );
}
/* paint tu cell */
void ptucell(int x,int y,int color) {
   int i;
   i=10*y+x;
   xv_set(tusbarcos_ptr[i],
	  RECTOBJ_BG, color,
	  NULL );
}

void fillenemyt( char filltable[] ,int a) {           /* new on v0.30 */
   int i,x,y;
   x=y=0;
   for(i=0;i<100;i++) {
      if(a==0)pmicell(x,y,filltable[i]);
      else if(a==1)ptucell(x,y,filltable[i]);
      x++;
      if(x==10) {
	 x=0;y++;
      }
   }
}
void fill0( int b,int a ) {           /* new on v0.30 */
   int i;
   int x,y;
   x=y=0;

   for(i=0;i<100;i++) {
      if(a==0)pmicell(x,y,b);
      else if(a==1)ptucell(x,y,b);
      x++;
      if(x==10) {
	 x=0;y++;
      }
   }
}

   
void repaintmi( void )  {
   int x,y;
   for(x=0;x<10;x++) {
      for(y=0;y<10;y++)  {
	 switch(mitabla[x][y]) {
	  case BARCO:
	    pmicell(x,y,GREEN);
	    break;
	  case NOBARCO:
	    pmicell(x,y,WHITE);
	    break;
	  case AGUA:
	    pmicell(x,y,BLUE);
	    break;
	  case TOCADO:
	    pmicell(x,y,RED);
	    break;
	  case HUNDIDO:
	    pmicell(x,y,BLACK);
	    break;
	 }
      }
   }
}

void repainttu( char outbuf[] )  {
   int x,y,i;
   for(x=0,y=0,i=0;i<MSGMAXLEN;i++) {
      if( outbuf[i]==TOCADO)
      	ptucell(x,y,RED);
      else if(outbuf[i]==HUNDIDO)
      	ptucell(x,y,BLACK);
      else if(outbuf[i]==AGUA)
      	ptucell(x,y,BLUE);
      else if(outbuf[i]==NOBARCO)
      	ptucell(x,y,WHITE);
      else if(outbuf[i]==BARCO)
      	ptucell(x,y,GREEN);
      x++;
      if(x>=10) {
	 x=0;y++;
      }
   }
}

void iwtable( char *dest) {
   int i,x,y;
   x=0;y=0;
   for(i=0;i<100;i++) {
      dest[i]=mitabla[x][y];
      x++;
      if(x>=10) {
	 x=0;
	 y++;
      }
   }
}
void filtermiboard()  {
   int x,y;

   for(x=0;x<10;x++) {
      for(y=0;y<10;y++) {
	 if(mitabla[x][y]>=BARCO) mitabla[x][y]=BARCO;
	 else {if(mitabla[x][y]<=NOBARCO) mitabla[x][y]=NOBARCO;}
      }
   }
}
   
/*
 *             FUNCIONES DE COMUNICACIONES
 */

size_t bnwrite(int fd,char *buf,char tip0,char tip1,char tip2,char jugyo ) {
   int i;
   
   struct protocolo proto;
   proto.bnptip0=tip0;
   proto.bnptip1=tip1;
   proto.bnptip2=tip2;
   proto.jugador=jugyo;
   for(i=0;i<MSGMAXLEN;i++)
     proto.bnpmsg[i]=buf[i];
   strcpy(proto.bnphead,BNPHEAD);
   proto.bnpver=BNPVER;
   return( write(fd,&proto,MAXLEN) ) ;
}

Notify_value proceso( ) {
   struct protocolo proto;
   char outbuf[MSGMAXLEN];
   char outbufi[MSGMAXLEN];
   int i;
   
   FD_SET(sock,&readfds);
   if(select(FD_SETSIZE,&readfds,NULL,NULL,&timeout)) {
      if( read(sock,&proto,MAXLEN) >0) {
	 switch(proto.bnptip0) {
	  case BNTST:
	    break;
	  case BNWRI:
	    if(proto.bnpmsg[0]==1) {
	       xv_set(panelcit2,
		      PANEL_LABEL_STRING,"     Start     ",
		      NULL); 
	       ttyfill("The board is OK. Press START to start the game.\n\r");
	       usuario.play=2;
	    }
	    else if(proto.bnpmsg[0]==0) {
	       ttyfill("Check board: Btserver reports an error.\n\r");
	       usuario.play=1;
	    }
	    break;
	  case BNJUG:
	    usuario.numjug=proto.bnptip1;
	    sprintf(outbuf,"Connected to btserver:%s",proto.bnpmsg);
	    foot_right(outbuf);
	    sprintf(outbuf,"Player %i",usuario.numjug);
	    foot_left(outbuf);
	    sprintf(outbuf,"Connected to btserver:%s. You are player number:%i.\n\r",proto.bnpmsg,usuario.numjug);
	    ttyfill(outbuf);
	    
	    usuario.play = 1;
	    xv_set(panelcito,
		   PANEL_LABEL_STRING,"Disconnect",
		   NULL); 
	    xv_set(panelcit2,
		   PANEL_BUSY,FALSE,
		   NULL);
	    xv_set(panelcit4,
		   PANEL_BUSY,FALSE,
		   NULL);
	    xv_set(panelcit5,              /* status */
		   PANEL_BUSY,FALSE,
		   NULL);

	    xv_set( drawtext1,
		   DRAWTEXT_STRING,"Enemy board",
		   NULL );
	    bnwrite(sock,outbuf,BNVER,usuario.usrfrom,bnsup,usuario.numjug);
	    
	    break;
	  case BNVER:
	    sprintf(outbuf,"btserver version:%i.%i\n\r",proto.bnpmsg[0],proto.bnpmsg[1]);
	    ttyfill(outbuf);
	    break;
	  case BNMSG:
	    strcpy(outbuf,proto.bnpmsg);
	    strcat(outbuf,"\n\r");
	    ttyfill(outbuf);
	    break;
	  case BNALL:
	    ttyfill("btserver is full. Using all the connections.Try later\n\r");
	    close(sock);
	    break;
	  case BNWAI:
	    ttyfill("You cant start a game while people are playing.Try later\n\r");
	    break;
	  case BNHIT:
	    if(usuario.play>=3) {
	       mitabla[(int)proto.bnpmsg[0]][(int)proto.bnpmsg[1]]=(int)proto.bnpmsg[2]; /* new on v0.44 */
	       if(usuario.hide==FALSE)
	       	 repaintmi();
	    }
	    bnwrite(sock,outbuf,BNREA,usuario.usrfrom,bnsup,usuario.numjug);
	    break;
	  case BNREA:
	    if(usuario.play>=3)
	      repainttu(proto.bnpmsg);
	    break;
	  case BNSTR:
	    foot_right("Please,wait your turn");
	    ttyfill("The game starts now! Please,wait your turn.\n\r"); /* new on v0.32 */
	    ttyfill("At the bottom-right corner you can see if its your turn.\n\r");
	    sprintf(outbuf,"Available players:");
	    
	    for(i=0;i<MAXPLAYER;i++) {
	       if(proto.bnpmsg[i]>=2) {
		  sprintf(outbufi," %i",i+1);
		  strcat(outbuf,outbufi);
		  strcpy(usuario.names[i],&proto.bnpmsg[5+i*MAXNAMELEN]);
		  xv_set(mi[i],MENU_STRING,usuario.names[i],NULL);
	       }
	    }
	    strcat(outbuf,".\n\r");
	    ttyfill(outbuf);
	    
	    foot_left(usuario.names[usuario.numjug-1]); /* new on v0.36 */
	    
	    if(usuario.play==2) {
	       usuario.play=3;
	       xv_set(panelcit2,
/*		      PANEL_LABEL_STRING,"Started",   */
		      PANEL_BUSY,TRUE,
		      NULL);
	       xv_set(panelcit3,
		      PANEL_BUSY,FALSE,
		      NULL);
	    }
	    for(i=0;i<MAXPLAYER;i++) {          /* new on v0.36 */
	       if(usuario.numjug-1!=i) {
		  if(strcmp(usuario.names[i],"")!=0) {
		     usuario.usrfrom=i+1;
		     sprintf(outbuf,"%s's board",usuario.names[i]);
		     xv_set( drawtext1,DRAWTEXT_STRING,outbuf,NULL );
		  }
	       }
	    }
	    break;
	  case BNCON:
	    sprintf(outbuf,"Player %i is ready to play\n\r",proto.bnptip1);
	    ttyfill(outbuf);
	    break;
	  case BNWHO:                          /* new on v0.32 */
	    sprintf(outbuf,"It's %s turn.",usuario.names[proto.bnptip1-1]);
	    foot_right(outbuf);
	    break;
	  case BNTRN:
	    usuario.play=4;                    /* oh, it is my turn */
	    foot_right("It's my turn.");
	    break;
	  case BNEXT:                          /* new on v0.36 */
	    i=proto.bnptip1-1;
	    usuario.names[i][0]=0;
	    xv_set(mi[i],MENU_STRING,usuario.names[i]);
	    strcpy(outbuf,proto.bnpmsg);
	    strcat(outbuf,"\n\r");
	    ttyfill(outbuf);
	   
	    for(i=0;i<MAXPLAYER;i++) {          /* new on v0.36 */
	       if(usuario.numjug-1!=i) {
		  if(strcmp(usuario.names[i],"")!=0) {
		     usuario.usrfrom=i+1;
		     sprintf(outbuf,"%s's board",usuario.names[i]);
		     xv_set( drawtext1,DRAWTEXT_STRING,outbuf,NULL );
		  }
	       }
	    }
	    if(usuario.play>=3) {
	       bnwrite(sock,outbuf,BNREA,usuario.usrfrom,bnsup,usuario.numjug);
	    }
	    break;
	  case BNLOS:
	    usuario.play=1;                    /* oh, i lost the game */
	    for(i=0;i<MAXPLAYER;i++)
	      usuario.names[i][0]=0;
	    ttyfill("You were killed. To start again wait until the game is over.\n\r");
	    fillenemyt(looseboard,1);
	    xv_set(panelcit2,
		   PANEL_LABEL_STRING,"Send Board",
		   PANEL_BUSY,FALSE,
		   NULL);
	    xv_set(panelcit3,
		   PANEL_BUSY,TRUE,
		   NULL);
	    usuario.firsthit=0;            /* new on v0.41 */
	    break;
	  case BNWIN:
	    usuario.play=1;                    /* oh, i lost the game */
	    for(i=0;i<MAXPLAYER;i++)
	      usuario.names[i][0]=0;
	    ttyfill("CONGRATULATIONS: You are the winner.\n\r");
	    fillenemyt(winboard,1);
	    xv_set(panelcit2,
		   PANEL_LABEL_STRING,"Send Board",
		   PANEL_BUSY,FALSE,
		   NULL); 
	    xv_set(panelcit3,
		   PANEL_BUSY,TRUE,
		   NULL);
	    usuario.firsthit=0;            /* new on v0.41 */
	    break;
	  case BNSOL:
	    ttyfill("You are the only one who sent the board.Wait another player.\n\r");
	    break;
	  case BNSTS:                    /* new on v0.43 */
	    for(i=0;i<MAXPLAYER;i++) {
	       sprintf(outbuf,"Player %i (%s), name='%s'\n\r"
		       ,i+1,usuario.status[(int)proto.bnpmsg[i]],&proto.bnpmsg[5+i*MAXNAMELEN]);
	       ttyfill(outbuf);
	    }
	    break;
	  default:
	    sprintf(outbuf,"BTSERVER sending code %X.  Not available in this xbtclient.\n\r",proto.bnptip0);
	    ttyfill(outbuf);
	    break;
	 }
      }
   }
   return NOTIFY_DONE;                    /* new on v0.30 */
}

int init_cliente( void ) {
   char outbuf[MSGMAXLEN];
   int i;
   
   if(usuario.play==0) {                  /* estado de un boton */
      /* Create socket */
      sock=socket(AF_INET,SOCK_STREAM,0);
      if(sock <0) {
	 ttyfill("ERROR: creating stream socket\n\r");
	 return(1);
      }
      host_info = gethostbyname(usuario.server_name);
      if(host_info==NULL) {
	 close(sock);           /* new on v0.38 */
	 ttyfill("ERROR: Unknown host.Please check CONFIG.\n\r");
	 return(2);
      }
      server.sin_family=host_info->h_addrtype;
      memcpy( (char*) &server.sin_addr, host_info->h_addr,host_info->h_length);
      server.sin_port=htons(usuario.port);
      
      
      if(connect(sock,(struct sockaddr *)&server,sizeof(server))< 0) {
	 close(sock);            /* new on v0.38 */
	 ttyfill("ERROR:Perhaps incorrect port number or btserver not running.Check CONFIG.\n\r");
	 return(2);
      }
      
      timer.it_value.tv_usec = RAPID * 1000;
      timer.it_interval.tv_usec = RAPID * 1000;
      notify_set_itimer_func(frame, proceso,ITIMER_REAL, &timer, NULL);
      
      strcpy(outbuf,usuario.nombre);
      bnwrite(sock,outbuf,BNJUG,XCLI,BN_XVERH,BN_XVERL);       /* WHO AM I */
      return(0);
   }
   else if(usuario.play!=0) {
      foot_right("(c) Ricardo Quesada");
      foot_left("Batalla Naval");
      xv_set(panelcito,
	     PANEL_LABEL_STRING,"  Connect  ",
	     NULL); 
      xv_set(panelcit2,
	     PANEL_LABEL_STRING,"Send Board",
	     PANEL_BUSY,TRUE,
	     NULL);
      xv_set(panelcit3,
	     PANEL_BUSY,TRUE,
	     NULL);
      xv_set(panelcit4,
	     PANEL_BUSY,TRUE,
	     NULL);
      xv_set(panelcit5,
	     PANEL_BUSY,TRUE,
	     NULL);

      usuario.firsthit=0;              /* new on v0.41 */
      for(i=0;i<MAXPLAYER;i++)
      	usuario.names[i][0]=0;
      usuario.play=0;
      bnwrite(sock,outbuf,BNEXT,0,0,usuario.numjug);
      close(sock);
   }
   return(0);
}
/*
*                            FUNCIONES X  y otras...
 */
void nada( void ) {
}
void menuses( Menu menu,Menu_item menu_item) {
   char outbuf[MSGMAXLEN];
   int i;
   
   for(i=0;i<MAXPLAYER;i++) {
      if(!strcmp((char *)xv_get(menu_item,MENU_STRING),usuario.names[i])) {
	 if(strcmp(usuario.names[i],"")!=0) {   /* not null. new on v0.36 */
	    sprintf(fijo01,"%s's board",usuario.names[i]);
/*	    xv_set( menu_item,MENU_STRING,usuario.names[i],NULL,NULL); */
	    xv_set( drawtext1,
		   DRAWTEXT_STRING,fijo01,
		   NULL );
	    usuario.usrfrom=i+1;
	 }
      }
   }
   if(usuario.play>=3) {
      bnwrite(sock,outbuf,BNREA,usuario.usrfrom,bnsup,usuario.numjug);
   }
}

void about( Frame item, Event *event ) {
   xv_set( subframe1, XV_SHOW, TRUE, NULL );
}

void send_msg( Frame item, Event *event ) {
   xv_set( subframe3, XV_SHOW, TRUE, NULL);
}

void status() {
   char tempbuf[100];
   if(usuario.play>=1) {
      bnwrite(sock,tempbuf,BNSTS,0,0,usuario.numjug);
   }
}

void about_proc( Canvas c, Xv_window pw, Display *display, Window xid, Xv_xrectlist *xrects ) {
   int w,h;
   w = xv_get(pw,XV_WIDTH);
   h = xv_get(pw,XV_HEIGHT);
   
   XSetForeground(display,gc,colors[LBLUE]);
   XFillRectangle(display, xid, gc, 0, 0, w, h/3 );
   XSetForeground(display,gc,colors[WHITE]);
   XFillRectangle(display, xid, gc, 0, h/3, w, h/3*2 );
   XSetForeground(display,gc,colors[LBLUE]);
   XFillRectangle(display, xid, gc, 0, h/3*2, w,h );
   XSetForeground(display,gc,colors[YELLOW]);
   XFillArc(display, xid, gc, w/3 + w/3 * .15, h/3 + h/3 *.15, h/3 * .7, h/3 * .7, 0, 360*64 );
   XSetForeground(display,gc,colors[BLACK]);
   XDrawString(display,xid,gc,90, 40,"Batalla Naval v"BN_XVER,19);
   XDrawString(display,xid,gc,126, 80,"X client",8);
   XDrawString(display,xid,gc,30,100 ,"by Ricardo Quesada (rquesada@dc.uba.ar)",39);
   XDrawString(display,xid,gc,124,140,"btserver",8);
   XDrawString(display,xid,gc,90,160,"by Ricardo Quesada",18);
   XDrawString(display,xid,gc,107,204,"ncurses client",14);
   XDrawString(display,xid,gc,90,224,"by Ricardo Quesada",18);
   XDrawString(display,xid,gc,50,260,"Hecho en Buenos Aires, Argentina",32);
}
   
void info( Frame item, Event *event ) {
   xv_set( subframe2, XV_SHOW, TRUE, NULL );
}
int server_port( Panel_item item, Event *event ) {
   usuario.port=(int)xv_get(item,PANEL_VALUE);
   return PANEL_NEXT;
}
int server_name( Panel_item item, Event *event ) {
   strcpy(usuario.server_name,(char *)xv_get(item,PANEL_VALUE));
   return PANEL_NEXT;
}
int your_name( Panel_item item, Event *event ) {
   strcpy(usuario.nombre,(char *)xv_get(item,PANEL_VALUE));
   return PANEL_NEXT;
}

int localecho( Panel_item item,unsigned value, Event *event ) {
   usuario.lecho=value;
   return XV_OK;
}
int to_player( Panel_item item, Event *event ) {
   usuario.towho=(int)xv_get(item,PANEL_VALUE);
   return PANEL_NEXT;
}
int to_message( Panel_item item, Event *event ) {
   strcpy(usuario.tomsg,(char *)xv_get(item,PANEL_VALUE));
   return PANEL_NEXT;
}
void real_message( void ) {         /* new on v0.34 - this send the message */
   if(usuario.play>=1)
     bnwrite(sock,usuario.tomsg,BNMSG,usuario.towho,usuario.lecho,usuario.numjug);
   else
     ttyfill("First establish a connection with CONNECT.\n\r");
   return;
}

/*                            ALGORITMO
 *                  CHEQUEAR SI LOS BARCOS ESTAN BIEN
 */

/* points to next pos.return TRUE . FALSE in case there are no more ships */
/* this rutine uses global x,y */
int nextbarco() {
   if(x==9) { 
      x=0;
      y++;
   }
   else x++;
   if( y==10 ) return FALSE;
   else return TRUE;
}    	
/* return TRUE if in (x,y) hay barco. else FALSE */
/* this rutine uses local x,y */
int haybarco( int x, int y) {
   if( (x < 0) || ( x > 9 ) || (y < 0) || (y >9 ) ) 
     return FALSE;
   if( mitabla[x][y]==1 ) 
     return TRUE;
   if( mitabla[x][y] == 0 ) 
     return FALSE;
   ttyfill("ABNORMAL ERROR in haybarco(): Please contact the author.\n\r");
   return FALSE;
}

/* return TRUE if board is OK .else return FALSE  */
int algoritmo( void )  {
   int i,xx,yy,barcos,subarco;
   char temporal[100];
   
   for(i=0;i<4;i++) barquitos[i]=0;
   
   /* global x,y */
   x=0;y=0;
   barcos=0;
   
   for(;;) {
      if(haybarco(x,y)==FALSE) {
	 if(nextbarco()==FALSE) {
	    if( (barquitos[3]==1) && (barquitos[2]==2) && (barquitos[1]==3) && (barquitos[0]==4) ) {
	       return TRUE;         /* tabla bien puesta */
	    }
	    else {
	       sprintf(temporal,"Check board: All numbers must be equal to 0. [4]=%i,[3]=%i,[2]=%i,[1]=%i\n\r",1-barquitos[3],2-barquitos[2],3-barquitos[1],4-barquitos[0]);
	       ttyfill(temporal);
	       return FALSE;
	    }
	 }
      }
      else { 
	 if( haybarco(x,y)==TRUE )  {
	    if( (haybarco(x,y-1)==FALSE) && (haybarco(x-1,y)==FALSE) ) {
	       /* this is the first time i check this */
	       subarco=1;
	       barcos++;
	       xx=x;yy=y;
	       
	       for(;;) {
		  if( (haybarco(x-1,y+1)==TRUE) || (haybarco(x+1,y+1)==TRUE) ) {
		     sprintf(temporal,"Check board: Collision in (x,y)=%i,%i\n\r",x+1,y+1);
		     ttyfill(temporal);
		     pmicell(x,y,RED);
		     return FALSE;
		  }
		  if( (haybarco(x+1,y)==FALSE) && (haybarco(x,y+1)==FALSE) ) {
		     x=xx;y=yy;          /* restauro pos */
		     barquitos[subarco-1]++; /* update cantidad de tama;os de barcos */
		     break;
		  }
		  else if( haybarco(x+1,y) == TRUE ) {
		     subarco++;
		     barcos++;
		     x++;
		  }          
		  else if( haybarco(x,y+1) == TRUE ) {
		     y++;
		     barcos++;
		     subarco++;
		  }
		  if( subarco > 4) {
		     sprintf(temporal,"Check board: Ship longer than 4 units in (x,y)=%i,%i\n\r",x+1,y+1);
		     ttyfill(temporal);
		     pmicell(x,y,RED);
		     return FALSE;
		  }
	       } /* for(;;) */
	    } /* if(haybarco(x,y-1)==FALSE) */
	 } /* if(haybarco(x,y)==TRUE) */
	 if(nextbarco()==FALSE) {
	    if( (barquitos[3]==1) && (barquitos[2]==2) && (barquitos[1]==3) && (barquitos[0]==4) ) {
	       return TRUE;         /* tabla bien puesta */
	    }
	    else {
	       sprintf(temporal,"Check board: All numbers must be equal to 0. [4]=%i,[3]=%i,[2]=%i,[1]=%i\n\r",1-barquitos[3],2-barquitos[2],3-barquitos[1],4-barquitos[0]);
	       ttyfill(temporal);
	       return FALSE;
	    }
	 } /* if nextbarco()==FALSE) */
      } /* else */
   } /* for(;;) */
} /* void algoritomo() */

/*
 *                     EMPEZAR LA PARTIDA
 */
int play( void ) {
   char outbuf[MSGMAXLEN];
   
   if(usuario.play==0) {         /* estado del boton SEND BOARD */
      filtermiboard();
      repaintmi();
      if(algoritmo()==TRUE)  {
	 ttyfill("Try first to establish a connection with CONNECT\n\r");
      }
      return(FALSE);
   }
   else if( usuario.play==1)  {
      filtermiboard();
      repaintmi();
      if( algoritmo()==FALSE) {
	 return(FALSE);
      }
      else if( algoritmo()==TRUE) {
	 iwtable( outbuf );
	 bnwrite(sock,outbuf,BNWRI,usuario.numjug,0,usuario.numjug);
	 return( TRUE );
      } /* close algorito==ok */
   }
   else if(usuario.play==2) {
      bnwrite(sock,outbuf,BNSTR,usuario.numjug,0,usuario.numjug);
   }
   else if(usuario.play>=3) {
      ttyfill("Que muchacho?.This mean that you are playing!\n\r");
   }
   return(TRUE);
}
/*
 *                          QUIT
 */
void quit( ) {
   char outbuf[MSGMAXLEN];
   if(usuario.play!=0){             /* if connected then kill child */
      bnwrite(sock,outbuf,BNEXT,0,0,usuario.numjug);
      close(sock);
   }
   xv_destroy_safe( frame );
}

/*
 *                           BUTTON PRESSED IN MY BOARD
 */
int mitabla_fn( Xv_window pw, Event *e, Canvas_shell cs, Rectobj r, int state)
{
   int x,y;

   if( (usuario.firsthit==0) && (usuario.play<2))  {        /* new on v0.30 */
      fill0(WHITE,1);              /* new on v0.41 */
      for(x=0;x<10;x++) {          /* clean tabla */
	 for(y=0;y<10;y++)
	   mitabla[x][y]=NOBARCO;
      }
      repaintmi(); 
      usuario.firsthit=1;
   }

   x=xv_get(r,XV_X) / ANCHO;
   y=xv_get(r,XV_Y) / LARGO;

   if( usuario.play >= 3 ) {
      ttyfill("You cant modify board while playing!\n\r");
      return(1);
   }
   if( usuario.play == 2 ) {
      ttyfill("The board is OK and you cant modify it now.\n\r");
      return(1);
   }

   if(mitabla[x][y]==NOBARCO)  {
      mitabla[x][y]=BARCO;
      xv_set(r,
	     RECTOBJ_BG,GREEN,
	     NULL);
   }
   else  {
      mitabla[x][y]=NOBARCO;
      xv_set(r,
	     RECTOBJ_BG,WHITE, 
	     NULL);
   }
   return(0);
}

void mitabla_fn2( )
{
   switch(usuario.hide) {
    case TRUE:
      usuario.hide=FALSE;
      repaintmi();
      break;
    case FALSE:
      usuario.hide=TRUE;
      fillenemyt(Hboard,0);
      break;
   }
}

/*
 *                           BUTTON PRESSED IN ENEMY BOARD
 */
int tutabla_fn( Xv_window pw, Event *e, Canvas_shell cs, Rectobj r, int state)
{
   int x,y;
   char outbuf[MSGMAXLEN];
   
   x=xv_get(r,XV_X) / ANCHO;
   y=xv_get(r,XV_Y) / LARGO;

   if( (usuario.firsthit==0) && (usuario.play<2)){        /* new on v0.30 */
      fill0(WHITE,1);              /* new on v0.41 */
      for(x=0;x<10;x++) {          /* clean tabla */
	 for(y=0;y<10;y++)
	   mitabla[x][y]=NOBARCO;
      }
      repaintmi(); 
      usuario.firsthit=1;
   }

   if( usuario.play < 3 ) {
      ttyfill("You cant HIT now. First start a game.\n\r");
      return(1);
   }
   else if( usuario.play == 3 ) {
      ttyfill("It is not your turn!\n\r");
      return(1);
   }
   usuario.play=3;                        /* it is no more your turn */
   outbuf[0]=x;
   outbuf[1]=y;
   bnwrite(sock,outbuf,BNHIT,0,0,usuario.numjug);
   bnwrite(sock,outbuf,BNREA,usuario.usrfrom,bnsup,usuario.numjug);
   return(1);
}

/*
 *                               INICIALIZAR VARIABLES
 */
void init_datos( void ) {
   int i,j;
   
   usuario.play = 0;
   usuario.usrfrom=1;
   usuario.lecho=1;
   for(i=0;i<10;i++) {          /* clean tabla */
      for(j=0;j<10;j++)
      	mitabla[i][j]=0;
   } 
   usuario.firsthit=0;
   for(i=0;i<MAXPLAYER;i++)
     usuario.names[i][0]=0;       /* clear all names */
   
   strcpy(usuario.status[DISCON],"not connected");
   strcpy(usuario.status[CONNEC],"  connected  ");
   strcpy(usuario.status[BOARD], "ready to play");
   strcpy(usuario.status[PLAY],  "   playing   ");
   strcpy(usuario.status[TURN],  "  playing *  ");
   usuario.hide=FALSE;
}

/*
 *                                 INICIALIZAR X
 */
void init_X( void ) {
   
   int i;
   
   /* crea los colores */
   cms = (Cms) xv_create( XV_NULL,CMS,
			 CMS_SIZE,7,
			 CMS_TYPE, XV_STATIC_CMS,
			 CMS_COLORS,cms_colors,
			 NULL );
   /* ventana principal */
   frame = (Frame) xv_create(XV_NULL, FRAME,
			     XV_HEIGHT,200,
			     XV_WIDTH,800,
			     FRAME_LABEL,"Batalla Naval X Client v"BN_XVER,
			     FRAME_SHOW_FOOTER,TRUE,
			     FRAME_LEFT_FOOTER,"Batalla Naval",
			     FRAME_RIGHT_FOOTER,"(c) Ricardo Quesada",
			     FRAME_SHOW_RESIZE_CORNER,FALSE,
			     NULL);
   



/* shell para mi tabla */
   shell = (Canvas_shell) xv_create( frame, CANVAS_SHELL,
				    WIN_CMS,cms,
				    NULL );
   xv_create( shell, DRAWTEXT,
	     DRAWTEXT_STRING,"Your board",
	     XV_WIDTH,ANCHO*10,
	     DRAWTEXT_JUSTIFY,DRAWTEXT_JUSTIFY_CENTER,
	     RECTOBJ_SELECTABLE,FALSE,
	     NULL); 
   array_tile = (Array_tile) xv_create( shell, ARRAY_TILE,
				       XV_Y,20, 
				       XV_WIDTH,ANCHO*10,
				       XV_HEIGHT,LARGO*10,
				       ARRAY_TILE_N_ROWS, 10,
				       ARRAY_TILE_N_COLUMNS, 10,
				       ARRAY_TILE_ROW_GAP, 1,
				       ARRAY_TILE_COLUMN_GAP, 1,
				       ARRAY_TILE_ROW_HEIGHT, 1,
				       ARRAY_TILE_COLUMN_WIDTH, 1,
				       RECTOBJ_EVENT_PROC, NULL,
				       NULL );
   proto_drawrect = (Drawrect) xv_create( XV_NULL, DRAWRECT,
					 RECTOBJ_SINGLE_CLICK_PROC, mitabla_fn,
					 RECTOBJ_EVENT_PROC, rectobj_button_event_proc,
  					 NULL);
   rectobj_ops = (Rectobj_ops*) xv_get(proto_drawrect,RECTOBJ_OPS);
   for(i=0;i<100;i++) {    /* 10 * 10 */
      barcos_ptr[i] = (Drawrect) xv_create( array_tile, DRAWRECT,
					   RECTOBJ_OPS, rectobj_ops,
					   XV_WIDTH,ANCHO,
					   XV_HEIGHT,LARGO,
					   DRAWRECT_BORDER2,1,
					   DRAWOBJ_FILLED,TRUE,
					   RECTOBJ_BG2, WHITE,
					   RECTOBJ_BG, WHITE,
					   RECTOBJ_FG, BLACK,
					   NULL );
   }
   xv_set( shell, 
	  XV_WIDTH, xv_get( array_tile, XV_WIDTH) ,
	  XV_HEIGHT, xv_get( array_tile, XV_HEIGHT) + 20 ,
	  NULL ); 

/* 
 * CREACION DEL PANEL DE LOS BOTONES
 * panel para los botones quit,play,etc 
 */
   panel = (Panel) xv_create( frame,PANEL,
			     PANEL_LAYOUT,PANEL_VERTICAL,
			     XV_WIDTH, 100,
			     NULL );

   panelcito = (Panel) xv_create(panel,PANEL_BUTTON,
				 PANEL_LABEL_STRING," Connect  ",
				 PANEL_NOTIFY_PROC,init_cliente,
				 NULL);
   panelcit2 = (Panel) xv_create(panel,PANEL_BUTTON,
				 PANEL_BUSY,TRUE,
				 PANEL_LABEL_STRING,"Send Board",
				 PANEL_NOTIFY_PROC,play,
				 NULL);

   panelcit5 = (Panel) xv_create(panel,PANEL_BUTTON,
				 PANEL_LABEL_STRING,"    Status    ",
				 PANEL_NOTIFY_PROC,status,
				 PANEL_BUSY,TRUE,
				 NULL);

   for(i=0;i<MAXPLAYER;i++) {
      mi[i] = (Menu_item) xv_create(XV_NULL,MENUITEM,
				    MENU_STRING,usuario.names[i],
				    MENU_NOTIFY_PROC,menuses,
				    NULL);
   }
   
   menu = (Menu) xv_create (XV_NULL, MENU,
			    MENU_GEN_PIN_WINDOW, frame, "Players",
			    NULL);
   for(i=0;i<MAXPLAYER;i++)
     xv_set(menu,MENU_APPEND_ITEM,mi[i],NULL);
			    
   panelcit3 = (Panel) xv_create(panel, PANEL_BUTTON,
             PANEL_BUSY,TRUE,
	     PANEL_LABEL_STRING," Players  ",
	     PANEL_NOTIFY_PROC,nada,
	     PANEL_ITEM_MENU,menu,
	     NULL);
   panelcit4 = (Panel) xv_create(panel,PANEL_BUTTON,        /* new on v0.34 */
             PANEL_BUSY,TRUE,
	     PANEL_LABEL_STRING," Send Msg  ",
	     PANEL_NOTIFY_PROC,send_msg,
	     NULL);
   xv_create(panel,PANEL_BUTTON,
	     PANEL_LABEL_STRING,"    Config   ",
	     PANEL_NOTIFY_PROC,info,
	     NULL); 
   xv_create(panel,PANEL_BUTTON,
	     PANEL_LABEL_STRING,"     About   ",
	     PANEL_NOTIFY_PROC,about,
	     NULL);
   xv_create(panel,PANEL_BUTTON,
	     PANEL_LABEL_STRING,"     Quit     ",
	     PANEL_NOTIFY_PROC,quit,
	     NULL);

/* 
 * CREACION DEL BOARD DEL ENEMIGO
 * shell para enemy tabla 
 */
   tushell = (Canvas_shell) xv_create( frame, CANVAS_SHELL,
				      WIN_CMS,cms,
				      NULL );
   drawtext1= (Drawtext) xv_create( tushell, DRAWTEXT,
			DRAWTEXT_STRING,"Enemy board",
			XV_WIDTH,ANCHO*10,
			DRAWTEXT_JUSTIFY,DRAWTEXT_JUSTIFY_CENTER,
			RECTOBJ_SELECTABLE,FALSE,
			NULL);
   array_tile = (Array_tile) xv_create( tushell, ARRAY_TILE,
				       XV_Y,20, 
				       XV_WIDTH,ANCHO*10,
				       XV_HEIGHT,LARGO*10,
				       ARRAY_TILE_N_ROWS, 10,
				       ARRAY_TILE_N_COLUMNS, 10,
				       ARRAY_TILE_ROW_GAP, 1,
				       ARRAY_TILE_COLUMN_GAP, 1,
				       ARRAY_TILE_ROW_HEIGHT, 1,
				       ARRAY_TILE_COLUMN_WIDTH, 1,
				       RECTOBJ_EVENT_PROC, NULL,
				       NULL );
   proto_drawrect = (Drawrect) xv_create( XV_NULL, DRAWRECT,
					 RECTOBJ_SINGLE_CLICK_PROC, tutabla_fn,
					 RECTOBJ_EVENT_PROC, rectobj_button_event_proc,
  					 NULL);
   rectobj_ops = (Rectobj_ops*) xv_get(proto_drawrect,RECTOBJ_OPS);
   for(i=0;i<100;i++) {    /* 10 * 10 */
      tusbarcos_ptr[i] = (Drawrect) xv_create( array_tile, DRAWRECT,
					      RECTOBJ_OPS, rectobj_ops,
					      XV_WIDTH,ANCHO,
					      XV_HEIGHT,LARGO,
					      DRAWRECT_BORDER2,1,
					      DRAWOBJ_FILLED,TRUE,
					      RECTOBJ_BG2, WHITE,
					      RECTOBJ_BG, WHITE,
					      RECTOBJ_FG, BLACK,
					      NULL );
   }
   xv_set( tushell, 
	  XV_WIDTH, xv_get( array_tile, XV_WIDTH) ,
	  XV_HEIGHT, xv_get( array_tile, XV_HEIGHT) + 20 ,
	  NULL ); 

/* 
 * todo lo referente a about
 */
   subframe1=(Frame) xv_create(frame,FRAME,
			       XV_HEIGHT,300,
			       XV_WIDTH,300,
			       FRAME_SHOW_FOOTER,TRUE,
			       FRAME_LEFT_FOOTER,"Batalla Naval",
			       FRAME_RIGHT_FOOTER,"(c) Ricardo Quesada",
			       FRAME_LABEL, "About",
			       FRAME_SHOW_RESIZE_CORNER,FALSE,
			       NULL);
   canvas = (Canvas) xv_create( subframe1,CANVAS,
			       CANVAS_X_PAINT_WINDOW,TRUE,
			       XV_VISUAL_CLASS, PseudoColor,
			       WIN_CMS,cms,
			       CANVAS_REPAINT_PROC,about_proc,
			       NULL );
   display = (Display *) xv_get( subframe1, XV_DISPLAY);
   xid = (XID) xv_get(  canvas_paint_window( canvas ) ,XV_XID );
   gc = (GC) XCreateGC( display, xid, XV_NULL , &gc_val );
   colors = (unsigned long*) xv_get( canvas,WIN_X_COLOR_INDICES);

/*
 * todo lo referente a Config
 */
   subframe2=(Frame) xv_create(frame,FRAME_CMD,
			       XV_HEIGHT,200,
			       XV_WIDTH,400,
			       FRAME_SHOW_FOOTER,TRUE,
			       FRAME_LEFT_FOOTER,"How to: After entering the name press ENTER, then press OK",
			       FRAME_LABEL, "Configuration",
			       NULL);
   panelinfo = (Panel) xv_get( subframe2,FRAME_CMD_PANEL);

/* (void) xv_create( panelinfo, PANEL_BUTTON,
*		    XV_X,50,
*		    XV_Y,150,
*		    PANEL_LABEL_STRING,"Cancel",
*		    PANEL_NOTIFY_PROC,nada,
*		    NULL); */
   xv_create( panelinfo, PANEL_BUTTON,
	     XV_X,190,
	     XV_Y,150,
	     PANEL_LABEL_STRING,"OK",
	     PANEL_NOTIFY_PROC,nada,
	     NULL); 
   xv_create( panelinfo, PANEL_TEXT,
   		          XV_X,70,
                          XV_Y,45,
			  PANEL_VALUE,usuario.server_name,
			  PANEL_LABEL_STRING,"Host name:",
			  PANEL_LAYOUT,PANEL_HORIZONTAL,
			  PANEL_NOTIFY_PROC, server_name,
			  PANEL_CLIENT_DATA, frame,
			  PANEL_VALUE_DISPLAY_LENGTH,20,
			  NULL);
   xv_create( panelinfo, PANEL_NUMERIC_TEXT,
	     XV_X,70,
	     XV_Y,70,
	     PANEL_LABEL_STRING,"Server port:",
	     PANEL_VALUE,usuario.port,
	     PANEL_MAX_VALUE,65535,
	     PANEL_MIN_VALUE,0,
	     PANEL_NOTIFY_PROC, server_port,
	     PANEL_CLIENT_DATA, frame,
	     PANEL_LAYOUT,PANEL_HORIZONTAL,
	     NULL);
   xv_create( panelinfo, PANEL_TEXT,
	     XV_X,70,
	     XV_Y,95,
	     PANEL_VALUE,usuario.nombre,
	     PANEL_LABEL_STRING,"Your name:",
	     PANEL_LAYOUT,PANEL_HORIZONTAL,
	     PANEL_VALUE_DISPLAY_LENGTH,20,
	     PANEL_NOTIFY_PROC, your_name,
	     PANEL_CLIENT_DATA, frame,
	     NULL);
   xv_create(panelinfo, PANEL_CHOICE,
	     XV_X,160,
	     XV_Y,120,
	     PANEL_FEEDBACK,PANEL_MARKED,
	     PANEL_CHOOSE_ONE,FALSE,
	     PANEL_LABEL_STRING,"Hide board:",
	     PANEL_VALUE, usuario.hide,
	     PANEL_CHOICE_STRINGS,"ON", NULL,
	     PANEL_NOTIFY_PROC,mitabla_fn2,
	     PANEL_CLIENT_DATA,frame,
	     NULL);
/*
 * todo lo referente a SEND MESSAGE
 */
   subframe3=(Frame) xv_create(frame,FRAME_CMD,
			       XV_HEIGHT,135,
			       XV_WIDTH,420,
			       FRAME_SHOW_FOOTER,TRUE,
			       FRAME_LEFT_FOOTER,"How to: After entering the message press ENTER, then press OK",
			       FRAME_LABEL, "Send Message",
			       FRAME_CMD_PIN_STATE,TRUE,
			       NULL);
   panel3 = (Panel) xv_get( subframe3,FRAME_CMD_PANEL);

   xv_create( panel3, PANEL_TEXT,
	     XV_X,20,
	     XV_Y,20,
	     PANEL_VALUE,"",
	     PANEL_LABEL_STRING,"Message:",
	     PANEL_LAYOUT,PANEL_HORIZONTAL,
	     PANEL_NOTIFY_PROC, to_message,
	     PANEL_CLIENT_DATA, frame,
	     PANEL_VALUE_DISPLAY_LENGTH,60,
	     NULL);
   xv_create( panel3, PANEL_NUMERIC_TEXT,
	     XV_X,20,
	     XV_Y,45,
	     PANEL_LABEL_STRING,"To Player (0=broadcast):",
	     PANEL_MAX_VALUE,MAXPLAYER,
	     PANEL_MIN_VALUE,0,
	     PANEL_NOTIFY_PROC, to_player,
	     PANEL_CLIENT_DATA, frame,
	     PANEL_LAYOUT,PANEL_HORIZONTAL,
	     NULL);
   xv_create(panel3, PANEL_CHOICE,
	     XV_X,160,
	     XV_Y,70,
	     PANEL_FEEDBACK,PANEL_MARKED,
	     PANEL_CHOOSE_ONE,FALSE,
	     PANEL_LABEL_STRING,"Local Echo:",
	     PANEL_VALUE, usuario.lecho,
	     PANEL_CHOICE_STRINGS,"ON", NULL,
	     PANEL_NOTIFY_PROC,localecho,
	     PANEL_CLIENT_DATA,frame,
	     NULL);
   
   xv_create( panel3, PANEL_BUTTON,
	     XV_X,200,
	     XV_Y,100,
	     PANEL_LABEL_STRING,"OK",
	     PANEL_NOTIFY_PROC,real_message,
	     NULL); 
  
   /* crea el icono - new on v0.31 */
   icon = (Icon) xv_create(XV_NULL, ICON,
			   ICON_IMAGE, xv_create(XV_NULL, SERVER_IMAGE,
						 XV_WIDTH, baticono_width,
						 XV_HEIGHT, baticono_height,
						 SERVER_IMAGE_X_BITS, baticono_bits,
						 NULL),
			   NULL);
   xv_set(frame, FRAME_ICON, icon, NULL);
   /*
    * Crea el panel donde van a ir a parar todos los mensajes.
    * new on v0.32
    */
   tty = (Tty) xv_create( frame,TTY,
			 XV_X,0,
			 WIN_BELOW,shell,
			 XV_HEIGHT,80,
			 XV_WIDTH,521,
			 TTY_ARGV,TTY_ARGV_DO_NOT_FORK,
			 NULL);
   
   /*
    * startup x, and run
    */
   window_fit( frame ); 

}

/*
 *                        main()
 */
void help() {
   printf("\n\nBatalla Naval X client v"BN_XVER"  (c) 1995,1996 Ricardo Quesada\n");
   printf("\nsyntax:");
   printf("\nxbtclient [options] [-s host_name] [-p server_port] [-u username]");
   printf("\n\n -s host_name:   The name of the host where btserver is running");
   printf(  "\n                 default is: localhost");
   printf(  "\n -p server_port: The number of the port that btserver is listening to");
   printf(  "\n                 default is: 1995");
   printf(  "\n -u username:    Your name or alias");
   printf(  "\n                 default is your login name");
   printf("\n\nSend bugs,doubts,fixes to rquesada@dc.uba.ar\n");
   exit(-1);
}

void main( int argc, char *argv[] )
{
   int i;
   xv_init( XV_INIT_ARGC_PTR_ARGV, &argc, argv, NULL);

   strcpy( usuario.server_name,"localhost");
   usuario.port=1995;     
   strcpy( usuario.nombre,getlogin());
   
   for(i=1;i<argc;i++) {
      if(argv[i][0]=='-') {
	 switch(argv[i][1]) {
	  case 'x':
	    bnsup=argv[i][2];
	    break;
	  case 's': case 'S':
	    if(argc>i+1) strcpy( usuario.server_name,argv[i+1]);
	    else help();
	    break;
	  case 'u': case 'U':
	    if(argc>i+1) strcpy( usuario.nombre,argv[i+1]);
	    else help();
	    break;
   	  case 'p': case 'P':
	    if(argc>i+1) usuario.port=atoi(argv[i+1]);
	    else help();
	    break;
	  case 'h': case 'H':
	  case '?': case '-':
	  default:
	    help();
	    break;
	 }
      }
      else {
	 if(argv[i-1][0]!='-')
	   help();
      }
   }

   
   init_datos();                  /* inicializa variables */
   init_X();              /* inicializa entorno y juego */
   ttyfill("BATALLA NAVAL X CLIENT v"BN_XVER" (c) 1995,1996 by Ricardo Quesada.\n\r");
   ttyfill("rquesada@dc.uba.ar - 17 Apr 96 - Buenos Aires, Argentina.\n\r");
   ttyfill("To start just fill your board with the ships then press SEND BOARD.\n\r");
   init_cliente();
   fillenemyt(Bboard,0);
   fillenemyt(Nboard,1);
   xv_main_loop(frame);
}
