! "main" (cells 983 length 114 width 173 generation 0)
! Orthogonal sawtooth
! Population is unbounded but does not tend to infinity.  Its graph is
! a sawtooth function with ever-increasing teeth.  More specifically,
! the population in generation  t = 18*21^n + 222  (n>=0),  is
! 7t/60 + 1290,  but the population in generation  6*21^n + 193  (n>=1)
! is only  1212.
!
! This uses a spark from a c/3 orthogonal spaceship to turn a HWSS into
! a loaf, which is then pulled back by pairs of LWSSs.  When the loaf
! is pulled all the way back, another HWSS is fired toward the c/3,
! starting the cycle again.  The HWSS synthesis, using 2 gliders, a
! Kok's galaxy, and a figure 8, is due to David Buckingham.
! Dean Hickerson, drhickerson@ucdavis.edu  4/10/91
57k86h@!
5...................................OO
5...................................O................OO
5........................OO.......O.O................O
5........................O..O.....OO
5..........O.O...............O
5........O...O...............O
5........O...................O
5.OO....O................O..O......OO
5.O......O...............OO........O.O...............O
5........O...O......................OOO.............OOO
5..........O.O.......................OO.............OOO
5.................................OO
5.................................OOO.............OO...OO
5...........................O.....................O.....O
5............................O
5..........................OOO.....OO
5..................................O......................OO
5...................................................O......O
5....................................................O.....O.O.......OO
5..................................................OOO......OO......OOO
9.O.O........................................................O.OO...............O
7.O3.O56.O..O15.O.O
OO5.O15.OO43.O.OO16.O.O
O5.O16.O..O24.O5.O13.3O14.O..O3.OO
7.O19.O23.O5.O14.OO14.O.O4.O
7.O3.O15.O6.OO16.O3.O30.O.O28.OO
9.O.O15.O6.O18.3O31.O31.O
23.O..O76.OO14.O.O9.O
23.OO78.O16.OO8.4O
38.OO52.O.O6.O.O25.OO.O8.OO
38.O53.O..O5.OO25.3O.O.O6.O..O
26.OO8.O.O38.O17.OO32.OO.O12.O
28.O7.OO38.O.O14.O3.OO20.OO9.4O11.O6.OO
15.OO12.O26.OO17.O.OO16.OO21.O..O9.O13.O6.O
15.O13.O26.O17.OO.OO13.O..O6.OO14.O22.O..O
12.OO15.O27.3O15.O.OO13.O.O6.O..O13.O22.OO
4.OO5.3O14.O8.OO20.O11.OO3.O.O25.O13.O.OO
4.O7.OO12.OO9.O24.O7.O.O4.O26.O15.O8.O
15.O31.OO12.O8.O30.OO.O22.OO
15.OO30.O13.3O5.OO31.O25.OO
37.3O79.OO
29.O8.OO55.O23.O12.OO
30.O4.OO9.3O47.OO4.OO28.O
28.3O4.3O8.OO18.OO27.OO5.O41.O
36.O.O10.OO16.O74.O.O
24.OO11.OO9.3O16.O.O7.OO42.OO7.OO9.O.O11.OO
24.O22.O.O18.OO5.O..O42.O8.3O7.O..O11.O
14.O32.OO25.O13.O43.OO.O5.O.O
13.O.O58.O11.4O42.O..O6.O.O
.OO10.OO.O8.O.O46.O12.O.OO41.OO.O8.O
.O11.OO.OO6.O..O47.O..O6.O.O.3O31.OO5.3O
13.OO.O6.OO52.OO8.O.OO31.O.O5.OO
13.O.O5.OO3.O59.4O8.OO22.O
14.O8.OO63.O9.O.O20.OO
24.O..O.....OO.................................................................O
24..O.O.....O.O................................................................OO
24............O
24............OO
.
24..............................O.......OOO
24..............................OO.OO.O..OO
24...............................O....OOO
24...........OO.OO.O.............O...O.O..O
24..........OO..OO.OO............O....O....O
24..................O............O....O....O
24..........OO...................O...O.O..O
24..........OO.....OO............O....OOO
24.................OO...........OO.OO.O..OO
24..........O.............OOO...O.......OOO
24..........OO.OO..OO.....OOO
24...........O.OO.OO......OOO
24...........................OOO
24...........................OOO
24...........................OOO
.
24................OO.......................OO
38.3O23.O44.O27.OO
26.O8.O.OO9.OO59.O.O26.O
26.O.O6.O..O9.O63.OO6.OO16.O.O9.O
27.O.O5.O.OO25.O47.OO4.O3.O16.OO8.4O
14.OO11.O..O7.3O22.OO.O45.OO3.O5.O24.OO.4O5.OO
14.O12.O.O9.OO25.O33.OO7.O.O4.OO.O3.O23.3O.OO3.O3.O..O
26.O.O37.O32.O.O7.O7.O5.O24.OO.OO3.O7.O
26.O36.O..O32.O18.O3.O7.OO17.5O3.O6.O6.OO
37.OO25.OO32.OO20.OO8.O.O17.O3.3O7.O6.O
37.O43.OO27.O21.O27.O..O
81.O26.OO22.OO26.OO
70.OO.......O.O...........................OO
70.O.O......OO......................................................O
57.O.O.............O.............................................................OO
56.O..O.....O....O..O..................OO
55.OO9.O6.O17.O..O41.O
53.OO3.O5.3O3.O.O21.O40.O.O
55.OO13.OO22.O39.O..O
49.OO5.O..O31.OO.O38.O..O24.O
48.O.O6.O.O32.O67.O.O
48.O66.O.O18.O7.O.O13.OO.O4.OO
47.OO34.OO29.O..O17.OO6.O..O13.OO.OO3.O
23.O24.O.OO30.O.O7.OO6.OO11.OO10.OO15.OO16.OO.O
23.OO23.O.O30.3O8.O7.O.O8.OO3.O8.O14.OO3.O14.O.O
14.OO8.OO14.O5.O.O..O29.OO20.O9.OO27.OO17.O
14.O9.3O13.O.O3.OO..OO32.OO14.O..O10.O..O18.OO5.O..O
24.OO15.O.O39.3O17.O11.O.O17.O.O6.O.O
23.OO16.O..O13.OO33.OO5.O.O32.O
23.O17.O.O16.O8.3O20.O.O5.OO32.OO
40.O.O.......OO.........O.........O...O.......OO.......O
40.O.........O..........O........O....O.O.....O.......OO
40......................O................OO
40.....................O.................OO
40...................OO..................OO
40....................................O.O....OO
40....................................O......O.O
40.............................................O
40.............................................OO
