! "main" (cells 558 length 69 width 113 generation 0)
! Orthogonal sawtooth
! Population is unbounded but does not tend to infinity.  Its graph is
! a sawtooth function with ever-increasing teeth.  More specifically,
! the population in generation  t = 36*11^n - 37  (n>=1),  is
! 7(t+1)/30 + 746,  but the population in generation  12*11^n - 51
! (n>=1)  is only 635 if n is even, 633 if n is odd.
! This uses a spark from a period 9, speed c/3 orthogonal spaceship,
! found by David Bell, to turn a LWSS into a loaf, which is then pulled
! back by pairs of LWSSs. When the loaf is pulled all the way back, it
! gets deleted and the cycle begins again.  (The deletion is caused by
! interaction with a LWSS and with 3 gliders which would otherwise form
! a LWSS.)
!
! Try putting something in the path of the c/3, far away from the guns.
! When the beam of LWSSs hits the resulting garbage, it is likely that
! a loaf will eventually be formed and pulled back.  No matter where
! the loaf starts, when it reaches the guns it will be deleted by one
! of 3 different reactions.  (The block behind the c/3 is used for one
! of these; it's not needed for the sawtooth pattern itself.)  The beam
! of LWSSs will again be released and may eventually form another loaf.
! The process may be repeated many times until either the LWSS beam
! burns through the garbage or the reaction moves upstream and consumes
! the guns.
! Dean Hickerson, drhickerson@ucdavis.edu  5/15/92
34k56h@!
36.....................................O
36...................................OOOO
36..........................OO.....OOOO.OO
36........................O..O...O...OO.OOO........OO................OO
36.......................O.......O...OO.OO..........O................O
36...............O.......O......O...OOOOO
36.OO............OO......O.......OOO...O
36.O..O...................O..O
22.O.O15.O20.OO40.O
20.O3.O15.O11.O48.O3.O
20.O11.O7.O11.O.O46.5O
13.O5.O10.O.O3.O..O15.OO6.OO35.OO3.OO
13.OO5.O10.OO3.OO17.OO8.O35.5O
20.O3.O30.OO3.O5.O35.3O
22.O.O27.O.O4.OO5.O36.O
51..O......O......O
51...............O.......OO
51.............OO........O.O..O.O
51...O.....................O...OO
51.OO......................OO..O
51..OO
51..................................................O.O
51...............OO.........OO......................OO
51..............O..O.......O..O......................O
12...OO...O............................................OOO.........OOO
12..OOO....O...............OO.............................OOOOOOOOO
12.O...OOO..................O............................O..OOOOO..O
11.OO.O.OO.O3.O9.O32.OO..3O..OO25.OO3.OO
12.O.O......OOO........OO
11.3O..O4.O..OO.O.OO.O69.O5.O
8.O.OO.O8.O3.3O3.O16.O29.O18.O
6.OO4.6O4.O..OO5.O15.O29.O18.O.O3.OO.OO
6.OO18.OO4.O.O13.O3.O25.O3.O15.O6.O
6.OO4.6O4.O..OO5.O7.OO6.4O26.4O30.O
8.O.OO.O8.O3.3O3.O6.4O67.3O
11.3O..O4.O..OO.O.OO.O5.OO.OO59.OO5.O
12.O.O6.3O8.OO5.OO62.O5.OO
11.OO.O.OO.O3.O9.O17.OO47.3O
12.O3.3O33.O47.O
13.OOO....O...............................O.O.........O
13..OO...O..............OO.................OO........O.O
34.O...........................O...OO......OO..............................OOO
24.O.O5.O.O27.O3.O7.O.O19.OO7.O3.O
23.O..O.....OO............................O...OO.......OOO..................O.O
13.O8.OO39.O.O10.3O7.O9.O7.O5.O
12.O.O5.OO3.O38.O10.3O7.OO17.OO3.OO
............OO.O......OO..................................................O.O
O...........OO.OO......O..O...............................................OO
OO..........OO.O........O.O
............O.O.........................................OO
.............O..........................................O.O
........................O...............................O
.......................OO
.
...........................OOO
.............................O............................................O
............................O.............................................O.O
59.OO..............O.O....OO..................OO...OO
14.OO..........................................OOO..............O..O....O
14.O33.O6.O.OO16.O.O24.O5.O
3.OO......OO............OO.....................OO.....O..O...............O.O
3.O6.3O14.O27.O.OO15.O28.OO.OO
11.OO15.O9.O19.3O44.O
14.O.............O........OO....................OO
14.OO............O
14..............O
14............OO
104..O
104.OO
