! "main" (cells 834 length 335 width 188 generation 17)
! Diagonal sawtooth
! David I. Bell, 16 Aug 1993
!
! This uses a period 960 glider gun, a Cordership, and two pentadecathelons.
! The glider gun attempts to fire a stream of gliders at a receding
! Cordership.  Each glider that reaches the Cordership is reflected by 180
! degrees and is returned on a parallel path.  Each returned glider is
! perturbed by a pentadecathelon so as to react with a glider from the
! outgoing glider stream.  The second pentadecathelon further perturbs the
! reaction to create a beehive.  The beehive is then deleted by the next
! glider in the stream.  Therefore each returning glider suppresses two
! outgoing gliders.
!
! There are the following phases for population growth and decline:
!
! 1. A stream of gliders grows from the glider gun to reach the Cordership,
!    which reflects those glider back into a second stream which is one half
!    the density of the outgoing stream.  The population of the gliders is
!    maximum when both streams are full.
!
! 2. The returning gliders turn off the outgoing stream by deleting pairs
!    of outgoing gliders.  This continues until all of the gliders that have
!    been sent out are consumed.  The population of the gliders is minimum (0)
!    when both streams are empty.
!
! Since the Cordership is receding, the glider streams get longer each
! cycle, and so this pattern is indeed a sawtooth.
!
! The expansion factor for this sawtooth is just 4.
! "main" (cells 418 length 306 width 168 generation 0)
153k84h@!
.............OO
.............O..O
.
.................O
.
...............OO
..............O
.
.
...........OO...OO
...........OO...OO
............OOOOO
.............O.O
.
.............OOO
.
..O......O
.OO......OO
OOO......OOO
.OO......OO
..O......O
102
104......................................OO
104......................................O.O
104.............................OO..OO......O...........O.O
104.............................OO.O..O..O..O..........O..O....O
104.................................OO......O.........OO.....OO
104......................................O.O........OO...O........OO
104......................................OO...........OO..........OO
104...........................................O........O..O
104.........................................OO..........O.O
104............................OO............OO
104............................O.O
104............................O
.
.
.
104..................................O.O
104..................................OO
104...................................O
.
.
104.......................OO
104.......................O.O
104..............OO..OO......O...........O.O
104..............OO.O..O..O..O..........O..O....O
104..................OO......O.........OO.....OO
104.......................O.O....OO..OO...O........OO
104.......................OO...........OO..........OO
104............................O........O..O
104..........................OO..........O.O
104...........................OO
104.....O.O..O.O
104.OO.O..O..O..O.OO
104.....O.O..O.O
.
104.................................OOO
104................................O...O
104...............................O.....O
.
104..............................O.......O
104..............................O.......O
.
104...............................O.....O
104................................O...O
104.................................OOO
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
17..............................OO
17..............................OO
17..................................OO
17...................................OO
17...................................O
17...................................OO
17..................................OO
.
17......................OO...........O
17......................OO.........OOO
17....................................O.O
17..................................O...OO
17......................................O
.
17..................................OOO
.
17..............OO
17..............OO
.
.
.
17.................................................O
17................................................OOO
17..................O
17......OO.....OOO.O.OOOO.......................O...O....O.O
17......OO........OO.O..........................O....OO.OOOOO
17..............OO....OO.O......................O..O.O..O...O
17.........................O.........................O
17.......................OO.O.OO..............................OO
17.........................OO.O................................OO
17...........................O.................................O
17.............................................................OO
17............................................................OO
17..............................O
17...........................OOO.OO............................O
17.........................OO.OOO............................OOO
17.............................O................................O.O
17.......O....................................................O...OO
17............................O...................................O
17..O.OO......................O
17..O.O......O................O...............................OOO
17.O....OO...O..............O.O
17..O........O...............O
17..O.......O
17...............OOO
17......O.........OO.OO
17................OO.O.........O......................................OO
17................O.O..........OO.....................................OO
17................O.O...........O
17.................OO........O.O
17...................O......O..O
17................O.O.......O.O
17...............O..........O.O
17...........................O
17............................................................OO
17.................O...O......................................OO
17.............O...O
17...................O
17..................OO
.
17...............OO.OO
17.................O
17....................................................OO
17.................................O..................OO
17..........................................OOO
17............................O.OO..........O.O
17............................O.O......O..OO..O
17...........................O....OO...O..OOO
17............................O........O..OOO
17............................O.......O
.
17................................O
