/* $Header: /u/klausf/schule/mata/projekt/memory/RCS/memory.c,v 1.2 1992/09/17 20:31:13 klausf Rel $
 *
 * $Log: memory.c,v $
 * Revision 1.2  1992/09/17  20:31:13  klausf
 * Korrektur der Initialisierung des Zufallsgenerators.
 *
 * Revision 1.1  92/09/15  09:37:23  klausf
 * Initial revision
 * 
 */


/*#define test 1*/

/* ----- INTERFACE */
#include "memory.h"

/* ----- IMPLEMENTATION*/

/* ----- USES */
#include "spielmem.h"


#include <time.h>
#ifdef __TURBOC__
#include <stdlib.h>
#else
#define random(n) (rand() % n)
#endif

#define srand() {time_t x; srand(time(&x));}

static char _id[] = "$Id: memory.c,v 1.2 1992/09/17 20:31:13 klausf Rel $";

typedef struct {
	int	Inhalt;
	int	offen;
} t_karte, *t_pkarte;

static int KARTEN;	/* Anzahl der Karten */
static int versuch;
static int erfolg;
static int zustand;	/* Das kann keine lokale static-Variable
			 * in DeckeAuf sein, weil Neues Spiel diese
			 * Variable auf 0 Setzen mu
			 */
static t_pkarte Karte;



int NeuesSpiel(unsigned Anzahl)
{
	int p, k;

	if (Karte)
		free(Karte);
	KARTEN = Anzahl * 2;
	if (! (Karte = (t_pkarte) malloc (KARTEN * sizeof(t_karte))))
		return 1;
	versuch = 0;
	erfolg = 0;
	zustand = 0;
	for (p = 0; p < KARTEN; ++p) {
		Karte[p].Inhalt = 0;
		Karte[p].offen  = 0;
	}
	srand();
	for (k = Anzahl; k; --k)
	{
		int pos = random(KARTEN);
		p = pos;
		do {
			pos = (pos + 1) % KARTEN;
		} while (Karte[pos].Inhalt != 0 && p != pos);
		Karte[pos].Inhalt = k;
		p = pos = random(KARTEN);
		do {
			pos = (pos + 1) % KARTEN;
		} while (Karte[pos].Inhalt != 0 && p != pos);
		Karte[pos].Inhalt = k;
	}
	Zeige();
}

void Zeige(void)
{
	int p;
	for (p=0; p < KARTEN; ++p) {
		if (Karte[p].offen)
			zeigeKarte (p, Karte[p].Inhalt);
		else
			zeigeKarte (p, RUECKSEITE);
	}
	Statistik (versuch, erfolg);
}


void DeckeAuf (unsigned p)

{
	static int	offene_karten[2];
	#define no	(offene_karten[0])
	#define noo	(offene_karten[1])

	if (p >= KARTEN)
		return;
	if (Karte[p].offen) {
		if (erfolg == KARTEN/2)
			Spielende();
		return;
	}

	switch (zustand) {
	case 2:
		Karte[no].offen = 0;
		zeigeKarte (no, RUECKSEITE);
		Karte[noo].offen = 0;
		zeigeKarte (noo, RUECKSEITE);
		/*FALLTHRU*/
	case 0:
		Karte[p].offen = 1;
		zeigeKarte (p, Karte[p].Inhalt);
		no = p;
		zustand = 1;
		break;
	case 1:
		Karte[p].offen = 1;
		zeigeKarte (p, Karte[p].Inhalt);
		if (Karte[p].Inhalt == Karte[no].Inhalt) {
			++erfolg;
			zustand = 0;
		} else {
			noo = p;
			zustand = 2;
		}
		++versuch;
		Statistik (versuch, erfolg);
	}
}
