/* $Header: /home/klausf/schule/mata/projekt/memory/RCS/tkmem.c,v 1.1 1994/08/03 18:39:10 klausf Exp $

cc -o tkmem tkmem.o memory.o /usr/X386/lib/libtk.a /usr/lib/libtcl.a -lX11 -lm

 * $Log: tkmem.c,v $
 * Revision 1.1  1994/08/03  18:39:10  klausf
 * Initial revision
 *
 */

#include <tcl/tcl.h>
#include <tcl/tk.h>
#include "memory.h"
#define KARTEN 25
#include "pix.data"

Tcl_Interp	*interpreter;

int tclNeuesSpiel (ClientData clientData, Tcl_Interp *interp,
	int argc, char *argv[])
{
	int N;
	if (argc != 2) {
		interp->result = "wrong # of args";
		return TCL_ERROR;
	}
	if (sscanf(argv[1], "%d", &N) != 1) {
		interp->result = "expected Number";
		return TCL_ERROR;
	}
	NeuesSpiel(N);
	interp->result = (char*)0;
	return TCL_OK;
}

int tclDeckeAuf (ClientData clientData, Tcl_Interp *interp,
	int argc, char *argv[])
{
	int N;
	if (argc != 2) {
		interp->result = "wrong # of args";
		return TCL_ERROR;
	}
	if (sscanf(argv[1], "%d", &N) != 1) {
		interp->result = "expected Number";
		return TCL_ERROR;
	}
	DeckeAuf(N);
	interp->result = (char*)0;
	return TCL_OK;
}


int tclZeige (ClientData clientData, Tcl_Interp *interp,
	int argc, char *argv[])
{
	if (argc != 1) {
		interp->result = "wrong # of args";
		return TCL_ERROR;
	}
	Zeige();
	interp->result = (char*)0;
	return TCL_OK;
}



void zeigeKarte (unsigned Nr, int Inhalt)
{
	char cmd[100];
	sprintf(cmd, "zeigeKarte %d %d", Nr, Inhalt);
	if (Tcl_Eval(interpreter, cmd) != TCL_OK)
		fprintf(stderr, "%s\n", interpreter->result);
}

void Statistik (unsigned Versuch, unsigned Erfolg)
{
	char cmd[100];
	sprintf(cmd, "Statistik %d %d", Versuch, Erfolg);
	if (Tcl_Eval(interpreter, cmd) != TCL_OK)
		fprintf(stderr, "%s\n", interpreter->result);
}

void Spielende(void)
{
	char cmd[] = "Spielende";
	if (Tcl_Eval(interpreter, cmd) != TCL_OK)
		fprintf(stderr, "%s\n", interpreter->result);
}


extern int main();
int *tclDummyMainPtr = (int *) main;
/*
 *----------------------------------------------------------------------
 *
 * Tcl_AppInit --
 *
 *	This procedure performs application-specific initialization.
 *	Most applications, especially those that incorporate additional
 *	packages, will have their own version of this procedure.
 *
 * Results:
 *	Returns a standard Tcl completion code, and leaves an error
 *	message in interp->result if an error occurs.
 *
 * Side effects:
 *	Depends on the startup script.
 *
 *----------------------------------------------------------------------
 */

int
Tcl_AppInit(interp)
    Tcl_Interp *interp;		/* Interpreter for application. */
{
    Tk_Window main;
    interpreter=interp;

    main = Tk_MainWindow(interp);

    /*
     * Call the init procedures for included packages.  Each call should
     * look like this:
     *
     * if (Mod_Init(interp) == TCL_ERROR) {
     *     return TCL_ERROR;
     * }
     *
     * where "Mod" is the name of the module.
     */

    if (Tcl_Init(interp) == TCL_ERROR) {
	return TCL_ERROR;
    }
    if (Tk_Init(interp) == TCL_ERROR) {
	return TCL_ERROR;
    }

    /*
     * Call Tcl_CreateCommand for application-specific commands, if
     * they weren't already created by the init procedures called above.
     */

	Tcl_CreateCommand (interp, "NeuesSpiel", tclNeuesSpiel,
		(ClientData)0, (Tcl_CmdDeleteProc *)0); 
	Tcl_CreateCommand (interp, "DeckeAuf", tclDeckeAuf,
		(ClientData)0, (Tcl_CmdDeleteProc *)0); 
	Tcl_CreateCommand (interp, "Zeige", tclZeige,
		(ClientData)0, (Tcl_CmdDeleteProc *)0); 

	{
	int i;
	char s[20];

	for (i=0; i <= KARTEN; ++i){
		sprintf(s, "pix_%d", i);
		if (Tk_DefineBitmap (interp, Tk_GetUid(s), pixdata[i], 
			PIX_SIZE, PIX_SIZE) != TCL_OK)
			fprintf(stderr, "%s\n", interp->result);
	}
	}

    /*
     * Specify a user-specific startup file to invoke if the application
     * is run interactively.  Typically the startup file is "~/.apprc"
     * where "app" is the name of the application.  If this line is deleted
     * then no user-specific startup file will be run under any conditions.
     */

    tcl_RcFileName = "~/.wishrc";
    return TCL_OK;
}
