/****************************************************************************************************************
 *
 *  Copyright (c) 1992 by Antoine Dumesnil de Maricourt. All rights reserved.
 *
 *  This program is distributed in the hope that it will be useful.
 *  Use and copying of this software and preparation of derivative works
 *  based upon this software are permitted, so long as the following
 *  conditions are met:
 *       o credit to the authors is acknowledged following current
 *         academic behaviour
 *       o no fees or compensation are charged for use, copies, or
 *         access to this software
 *       o this copyright notice is included intact.
 *  This software is made available AS IS, and no warranty is made about 
 *  the software or its performance. 
 * 
 *  Bug descriptions, use reports, comments or suggestions are welcome.
 *  Send them to    dumesnil@etca.fr   or to:
 *       
 *       Antoine de Maricourt
 *       ETCA CREA-SP
 *       16 bis, avenue Prieur de la Cote d'Or
 *       94114 Arcueil Cedex
 *       France
 */

#include "sg.h"

SG_KWData sg_keywords[] = {
  { ""        , ""                , SG_Illegal         , 0                                           , },
  { "B"       , "Black"           , SG_Black           ,                SG_MoveType                  , },
  { "W"       , "White"           , SG_White           ,                SG_MoveType                  , },
  { "C"       , "Comment"         , SG_Comment         , SG_EventType | SG_MoveType | SG_DiagramType , },
  { "N"       , "nodeName"        , SG_nodeName        , SG_EventType | SG_MoveType | SG_DiagramType , },
  { "V"       , "nodeValue"       , SG_nodeValue       , SG_EventType | SG_MoveType | SG_DiagramType , },
  { "CH"      , "CHeck"           , SG_CHeck           ,                SG_MoveType                  , },
  { "GB"      , "GoodBlack"       , SG_GoodBlack       ,                SG_MoveType                  , },
  { "GW"      , "GoodWhite"       , SG_GoodWhite       ,                SG_MoveType                  , },
  { "TE"      , "TEsuji"          , SG_TEsuji          ,                SG_MoveType                  , },
  { "BM"      , "BadMove"         , SG_BadMove         ,                SG_MoveType                  , },
  { "BL"      , "BlackLeft"       , SG_BlackLeft       , SG_EventType | SG_MoveType | SG_DiagramType , },
  { "WL"      , "WhiteLeft"       , SG_WhiteLeft       , SG_EventType | SG_MoveType | SG_DiagramType , },
  { "FG"      , "FiGure"          , SG_FiGure          , SG_EventType | SG_MoveType | SG_DiagramType , },
  { "AB"      , "AddBlack"        , SG_AddBlack        , SG_EventType |               SG_DiagramType , },
  { "AW"      , "AddWhite"        , SG_AddWhite        , SG_EventType |               SG_DiagramType , },
  { "AE"      , "AddEmpty"        , SG_AddEmpty        , SG_EventType |               SG_DiagramType , },
  { "PL"      , "PLayer"          , SG_PLayer          , SG_EventType |               SG_DiagramType , },
  { "GN"      , "GameName"        , SG_GameName        , SG_EventType                                , },
  { "GC"      , "GameComment"     , SG_GameComment     , SG_EventType                                , },
  { "EV"      , "EVent"           , SG_EVent           , SG_EventType                                , },
  { "RO"      , "ROund"           , SG_ROund           , SG_EventType                                , },
  { "DT"      , "DaTe"            , SG_DaTe            , SG_EventType                                , },
  { "PC"      , "PlaCe"           , SG_PlaCe           , SG_EventType                                , },
  { "PB"      , "PlayerBlack"     , SG_PlayerBlack     , SG_EventType                                , },
  { "PW"      , "PlayerWhite"     , SG_PlayerWhite     , SG_EventType                                , },
  { "RE"      , "REsult"          , SG_REsult          , SG_EventType                                , },
  { "US"      , "USer"            , SG_USer            , SG_EventType                                , },
  { "TM"      , "TiMe"            , SG_TiMe            , SG_EventType                                , },
  { "SO"      , "SOurce"          , SG_SOurce          , SG_EventType                                , },
  { "GM"      , "GaMe"            , SG_GaMe            , SG_EventType                                , },
  { "SZ"      , "SiZe"            , SG_SiZe            , SG_EventType                                , },
  { "VW"      , "VieW"            , SG_VieW            , SG_EventType | SG_MoveType | SG_DiagramType , },
  { "BS"      , "BlackSpec"       , SG_BlackSpec       , SG_EventType                                , },
  { "WS"      , "WhiteSpec"       , SG_WhiteSpec       , SG_EventType                                , },
  { "EL"      , "EvaLuation"      , SG_EvaLuation      , SG_EventType | SG_MoveType | SG_DiagramType , },
  { "EX"      , "EXpected"        , SG_EXpected        , SG_EventType | SG_MoveType | SG_DiagramType , },
  { "SL"      , "SeLected"        , SG_SeLected        , SG_EventType | SG_MoveType | SG_DiagramType , },
  { "M"       , "Marked"          , SG_Marked          , SG_EventType | SG_MoveType | SG_DiagramType , },
  { "L"       , "Letters"         , SG_Letters         , SG_EventType | SG_MoveType | SG_DiagramType , },
  { "BR"      , "BlackRank"       , SG_BlackRank       , SG_EventType                                , },
  { "WR"      , "WhiteRank"       , SG_WhiteRank       , SG_EventType                                , },
  { "HA"      , "HAndicap"        , SG_HAndicap        , SG_EventType                                , },
  { "KM"      , "KoMi"            , SG_KoMi            , SG_EventType                                , },
  { "TB"      , "TerritoryBlack"  , SG_TerritoryBlack  , SG_EventType | SG_MoveType | SG_DiagramType , },
  { "TW"      , "TerritoryWhite"  , SG_TerritoryWhite  , SG_EventType | SG_MoveType | SG_DiagramType , },
  { "SC"      , "SeCure"          , SG_SeCure          , SG_EventType | SG_MoveType | SG_DiagramType , },
  { "RG"      , "ReGion"          , SG_ReGion          , SG_EventType | SG_MoveType | SG_DiagramType , },
  { "KO"      , "KO"              , SG_KO              ,                SG_MoveType                  , },
  { ""        , ""                , SG_Illegal         , 0                                           , },
};
