.TH XTROJKA 6 "1 Mar 1996"
.SH NAME
xtrojka \- a game of skill.
.SH USAGE
.B xtrojka [-scores] [-help] [-debug] [X11 options]
.SH OPTIONS
.IP \-scores
Display high-scores.
.IP \-help
Show a short help text.
.IP \-debug
Show a bunch of debug messages.
.IP X\ options
Specifies the display on which
.IR xtrojka
will be run. See 
.BR X(1)
for further details.
.SH DESCRIPTION
.IR xtrojka
is the X version of an old game called Trojka. It finally
packs the thrills of Tetris
and the combinations of Columns into one (I hope) attractive game.
.PP
The name
.IR Trojka
is derived from the Russian word "Trojka", which
means "three", or "triple".
The aim of this game is to control and to place the falling blocks,
so that at least three blocks horizontally or diagonally, or both,
have matching patterns or colors. This sequence is then removed, and the above 
blocks will collapse. The latter sequence is repeated as long as
there are matching patterns after each collapsion.
A sequence of three immediate collapsions results in a socalled
"Trojka",  which is rewarded with bonus points.
If you reach the top of the screen, the game is finished. 
.PP 
.IR xtrojka
is menu-controlled, so here comes a short description of the menu's.
.PP The
.B TROJKA
Menu
.LP
.TP 15
.I New\ game
start a new game. Your old game must be finished.
.TP
.I Abort\ game
finish a game by selecting this menu option.
.TP
.I Wizard
When this option is checked, you play in a socalled wizard mode. This means
that combinations of blocks appear at the bottom of the screen. Only real
Trojka wizards know how to cope with this. If you played in wizard mode,
an asterisk will appear in the highscore list.
.TP
.I Slick
With this option you can choose between slick shadowed blocks, or 
unicolored blocks. 
.TP
.I Quit
Well, this item quits the program.
.PP The
.B SPEED
Menu
.LP
With this menu you can select your favorite game speed. Beware, the speed
will slowly increase, the longer you play. Once playing, you cannot switch
back to a slower speed.

.SH PREFERENCES
The speed and preferences are automatically stored in your homedir under
the name
.I \.xtrojka\.prefs\.bin.
This is a binary file, it cannot be edited.

.SH KEYS
The falling blocks are controlled using the arrows, but of course
you can also use the keys of the alltime favorite Vi-editor:
.PP

.TP 20
Left arrow,h
left
.TP
Right arrow,l
right
.TP
Insert, Down arrow ,j,<SPACE>
drop
.TP
Up arrow, k
increase speed

.SH FILES
.TP 15
 __SCOREDIR__
The 
.IR xtrojka
highscore file
.TP
 .xtrojka.prefs.bin
The file in your homedir where the preferences are stored. This is
a binary file which you cannot edit. The preferences have to be set from
the menu.

.SH HISTORY
In 1989 the very first version was written for MS-Dog.
In 1990 the game was ported to PRIMOS, running on the local Prime
system at the Eindhoven Polytechnic.
In 1991 versions were written for Windows and the Commodore Amiga.
In 1992 the Unix terminal-version became available 
The Apple Macintosh version was released in 1993.
In 1994 the X-version 1.0 was written and released in 1995 after
minor bugfixes. An OS/2 version was written in 1996.
See also the README file for a more complete version history of the
X-version.

.SH AUTHORS
The MS-DOS, UNIX, Macintosh and this version as well as the whole game-concept
is copyrighted by Maarten Los.
Prime version (c) Jac Goudsmit, Joran Jessurun, Richard Moeskops and me.
Amiga version (c) Joran Jessurun and Richard Moeskops.
MS Windows version (c) Jac Goudsmit. OS/2 version (c) Edwin Groothuis
.PP
Send all comments and bug-reports to:
.PP
maarten@djoe.iaf.nl

.SH BUGS
The preferences are stored
in a very Unix-unlike way, a not editable binary file. The
locking system of the multiuser scorefile watcher is poor.  The sound
is also poor. In fact, there isn't any sound at all. 
.PP
Some strings are compiled-in, especially the ones shown when the
game isn't initialized for X yet. This prevents setting them
.I all
from a the application resource file.

.SH DISCLAIMER
All brandnames listed are trademarks of their respective owners.
See also the Copyright notice that comes with the source code.



