.TH XVIER 6 "21 April 1992"
.SH NAME
xvier \- a X11 board game.
.SH SYNOPSIS
.B "xvier
[
.B \-display
.I displayname
] [
.B \-geometry
.I geometry
] [
.B \-fn
.I fontpattern
] [
.B \-iconic
] [
.B \-rows
.I rows
] [
.B \-columns
.I columns
] [
.B \-prog
.I programpath
] [
.B \-level
.I levelnumber
]
.SH DESCRIPTION
.I Xvier
is a board game where you and the computer alternately throw stones
into free columns. The stones pile up in the columns, and the goal is
to get four stones in a row, in a column or diagonally. You can choose
various board sizes and levels of difficulty.
.LP
During the game you click with the mouse onto the column where you
want to put your stone. Another possibility is a lower case letter in
the range 'a' to 'm' (maximally) where 'a' is the left column. If you
want to change the level of difficulty, you must use the keyboard.
Simply type the number of the desired level. These levels correspond
to the search depth of the game program. The meaning of the command
line options and buttons is given below.
.LP
While the game program computes a move, everything besides
.I "Change"
and
.I "Quit"
is blocked.
.SH OPTIONS
.TP
.BI \-display " displayname"
The X11 screen you want to use.
.TP
.BI \-geometry " geometry"
The desired geometry of the game window.
.TP
.BI \-fn " fontpattern"
A pattern describing the fonts which are used for the buttons and
messages.
.I Xvier
chooses the biggest font that fits into the window. Therefore the
pattern should describe different sizes of one font. The default is
\fB*-Helvetica-Medium-R-Normal-*\fP.
.TP
.B \-iconic
Start in iconic state.
.TP
.BI \-rows " rows"
The number of rows of the board. The possible range is 4 to 13. The
default is 6.
.TP
.BI \-columns " columns"
The number of columns of the board. The possible range is 4 to 13. The
default is 7.
.TP
.BI \-prog " programpath"
The path of the game program.
.TP
.BI \-level " levelnumber"
The level of difficulty to start with. The possible range is 0 to 9.
The default is 0.
.SH BUTTONS
The keyboard equivalents of the buttons are given in brackets.
.LP
.IP "\fBQuit ['q' or 'Q']\fP" 20
Finish the game.
.IP "\fBNew ['n' or 'N']\fP" 20
Start a new game.
.IP "\fBUndo ['u' or 'U']\fP" 20
Undo one move.
.IP "\fBStart ['s' or 'S']\fP" 20
Let the computer begin with the first move. The board must be empty.
.IP "\fBChange ['C']\fP" 20
Exchange the colours of your and the computer's stones.
.SH AUTHOR
.br
Norbert Jung	jung@dia.informatik.uni-stuttgart.de
